//------------------------------------------------------------------------------
/*
    This file is part of Bottle2D.

    Bottle2D is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bottle2D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bottle2D.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#include "ScreenRenderer.hpp"
//------------------------------------------------------------------------------
#include "MyException.hpp"
//------------------------------------------------------------------------------
#include "Screen.hpp"
#include "Drawable.hpp"
//------------------------------------------------------------------------------
namespace En
{
using namespace std;
//------------------------------------------------------------------------------
ScreenRenderer::ScreenRenderer(Group *parent, const std::string &name) : Drawable(parent, name), m_targetScreen(NULL)
{
    //ctor
}
//------------------------------------------------------------------------------
void ScreenRenderer::Render(sf::RenderTarget &App)
{
    const sf::View &backView = App.GetView();
    if(m_targetScreen)
    {
        m_targetScreen->Render(App);
    }
    App.SetView(backView);
}
//------------------------------------------------------------------------------
void ScreenRenderer::SetTargetScreen(Screen *targetScreen)
{
    if(GetParentScreen() == targetScreen)
    {
        MY_THROW("Screen Renderer : a screen can't render itself !");
    }

    m_targetScreen = targetScreen;
}
//------------------------------------------------------------------------------
} // namespace En
//------------------------------------------------------------------------------
